#include "StdAfx.h"
#include ".\panel.h"

#include "ScriptletConstant.h"

REGISTER_COMPONENT_CREATOR(SCRIPTLET_PANEL_NODE, CNPanel);
/************************************************************************/
/* IPanelUI */
/************************************************************************/
IMPLEMENT_RTTI(IPanelUI, IComponentUI)
IMPLEMENT_RTTI(CN4StatePanel, CNPanel)

/************************************************************************/
/* CNPanel */
/************************************************************************/
IMPLEMENT_RTTI(CNPanel, CNControl)

CNPanel::CNPanel(void)
{
}

CNPanel::~CNPanel(void)
{
}
void CNPanel::SetUI(IComponentUI* pPanelUI)
{
	///< only panel ui class
	if (NULL != pPanelUI &&
		IS_KIND_OF(IPanelUI, pPanelUI))
	{
		__super::SetUI(pPanelUI);
	}
}
void CNPanel::OnDraw(HDC hDC)
{	
	if (NULL != m_pComponentUI &&
		IS_KIND_OF(IPanelUI, m_pComponentUI))
	{
		IPanelUI* pPanelUI= reinterpret_cast<IPanelUI*>(m_pComponentUI);
		pPanelUI->DrawPanel(hDC, this);
	}
	__super::OnDraw(hDC);
}

//////////////////////////////////////////////////////////////////////////

CN4StatePanel::CN4StatePanel() 
{  
	m_state = E_PANEL_4STATE_NORMAL;
	m_bFirstIn = TRUE;
}

void CN4StatePanel::SetState(ePanelState ePanelState)
{
	m_state = ePanelState;
}

CN4StatePanel::ePanelState CN4StatePanel::GetState()
{
	return m_state;
}

void CN4StatePanel::OnMouseLeave()
{
	__super::OnMouseLeave();

	m_state = E_PANEL_4STATE_NORMAL;
	m_bFirstIn = TRUE;
	Invalidate();
}

void CN4StatePanel::OnMouseMove(UINT nFlags, CPoint point)
{
	__super::OnMouseMove(nFlags, point);

	if(m_bFirstIn == FALSE) return;

	m_state = E_PANEL_4STATE_OVER;
	Invalidate();
	m_bFirstIn = FALSE;
}